PGREP(1)

NOME
pgrep, pkill, pidwait - look up, signal, or wait for processes based on name and other attributes

SINOPSE
pgrep [opções] padrão
pkill [opções] padrão
pidwait [options] pattern

DESCRIÇÃO
pgrep examina os processos atualmente em execução e lista os IDs de processo que combinam os critérios de seleção para stdout (saída padrão). Todos os critérios devem corresponder. Por exemplo,

    $ pgrep -u root sshd

vai listar apenas os processos chamados sshd E pertencentes ao root. Por outro lado,

    $ pgrep -u root,daemon

vai listar os processos pertencentes ao root OU daemon.

pkill vai enviar um sinal especificado (por padrão, SIGTERM) para cada processo em vez de listá-los na stdout (saída padrão).

pidwait will wait for each process instead of listing them on stdout.

OPÇÕES

-sinal
--signal sinal
    Define o sinal para enviar para cada processo correspondente. Tanto nome numérico quanto o simbólico do sinal podem ser usado. (pkill apenas)

-c, --count
    Suppress normal output; instead print a count of matching processes. When count does not match anything, e.g. returns zero, the command will return non-zero value. Note that for pkill and pidwait, the count is the number of matching processes, not the processes that were successfully signaled or waited for.

-d, --delimiter delimitador
    Define a sequência usada para delimitar cada ID de processo na saída (por padrão, uma nova linha). (pgrep apenas.)

-e, --echo
    Exibe o nome e o PID do processo sendo terminado. (pkill apenas.)

-f, --full
    O padrão normalmente é analisado pelo nome do processo. Quando -f é definido, a linha de comando completa é usada.

-g, --pgroup pgrp,...
    Only match processes in the process group IDs listed. Process group 0 is translated into pgrep's, pkill's, or pidwait's own process group.

-G, --group gid,...
    Corresponde apenas aos processos cujo ID de grupo real está listado. Ou o valor numérico ou simbólico pode ser usado.

-i, --ignore-case
    Corresponde aos processos sem diferenciar maiúsculo/minúsculo.

-l, --list-name
    Lista o nome do processo, bem como o ID do processo. (pgrep apenas.)

-a, --list-full
    Lista o linha de comando completa, bem como o ID do processo. (pgrep apenas.)

-n, --newest
    Seleciona apenas o mais novo (iniciado mais recentemente) dos processos correspondentes.

-o, --oldest
    Seleciona apenas o mais antigo (iniciado menos recentemente) dos processos correspondentes.

-O, --older segundos
    seleciona onde mais antigo que segundos

-P, --parent ppid,...
    Corresponde apenas processos cujo ID de processo pai está listado.

-s, --session sid,...
    Only match processes whose process session ID is listed. Session ID 0 is translated into pgrep's, pkill's, or pidwait's own session ID.

-t, --terminal tty,...
    Corresponde apenas os processos cujo terminal controlador está listado. O nome do terminal deve ser especificado sem o prefixo "/dev/".

-u, --euid euid,...
    Corresponde apenas os processos cujo ID de usuário efetivo está listado. Ou o valor numérico ou simbólico pode ser usado.

-U, --uid uid,...
    Corresponde apenas os processos cujo ID de usuário real está listado. Ou o valor numérico ou simbólico pode ser usado.

-v, --inverse
    Negates the matching. This option is usually used in pgrep's or pidwait's context. In pkill's context the short option is disabled to avoid accidental usage of the option.

-w, --lightweight
    Shows all thread ids instead of pids in pgrep's or pidwait's context. In pkill's context this option is disabled.

-x, --exact
    Corresponde apenas a processos cujos nomes (ou linhas de comando, se -f for especificado) corresponderem exatamente ao padrão.

-F, --pidfile arquivo
    Read PIDs from file. This option is more useful for pkillorpidwait than pgrep.

-L, --logpidfile
    Falha se o arquivo de pid (veja -F) não estiver travado.

-r, --runstates D,R,S,Z,...
    Corresponde apenas processos que correspondem ao estado de processo.

-A, --ignore-ancestors
    Ignore all ancestors of pgrep, pkill, or pidwait. For example, this can be useful when elevating with sudo or similar tools.

--cgroup name,...
    Match on provided control group (cgroup) v2 name. See cgroups(8)

--ns pid
    Corresponde processos que pertencem aos mesmos espaços de nomes. É necessário executar como root para corresponder processos de outros usuários. Veja --nslist para como limitar quais espaços de nomes para corresponder.

--nslist nome,...
    Corresponde apenas aos espaços de nomes fornecidos. Espaços de nomes disponíveis: ipc, mnt, net, pid, user, uts.

-q, --queue valor
    Use sigqueue(3) em vez de kill(2) e o argumento de valor é usado para especificar um inteiro a ser enviado com o sinal. Se o processo de recebimento instalou um manipulador para este sinal usando o sinalizador SA_SIGINFO para sigaction(2), então ele pode obter esses dados através do campo si_value da estrutura siginfo_t.

-V, --version
    Exibe informação da versão e sai.

-h, --help
    Exibe a ajuda e sai.

OPERANDOS

padrão
    Especifica uma expressão regular estendida para corresponder nomes de processos ou linhas de comandos.

EXEMPLOS
Exemplo 1: Localizar o ID de processo do daemon named:

    $ pgrep -u root named

Exemplo 2: Fazer o syslog reler seu arquivo de configuração:

    $ pkill -HUP syslogd

Exemplo 3: Fornecer informação detalhada todos processos de xterm:

    $ ps -fp $(pgrep -d, -x xterm)

Exemplo 4: Fazer todos os processos do chrome serem executados com nice maior:

    $ renice +4 $(pgrep chrome)

STATUS DE SAÍDA
0   One or more processes matched the criteria. For pkill and pidwait, one or more processes must also have been successfully signalled or waited for.
1   Nenhum processo correspondido ou nenhum deles pode ser sinalizado.
2   Erro de sintaxe na linha de comando.
3   Erro fatal: memória insuficiente etc.

NOTAS
The process name used for matching is limited to the 15 characters present in the output of /proc/pid/stat. Use the -f option to match against the complete command line, /proc/pid/cmdline. Threads may not have the same process name as the parent process but will have the same command line.

The running pgrep, pkill, or pidwait process will never report itself as a match.

The -O --older option will silently fail if /proc is mounted with the subset=pid option.

ERROS
As opções -n, -o e -v não podem ser combinadas. Me avise se você precisar fazer isso.

Os processos defeituosos são relatados.

pidwait requires the pidfd_open(2) system call which first appeared in Linux 5.3.

VEJA TAMBÉM
ps(1), regex(7), signal(7), sigqueue(3), killall(1), skill(1), kill(1), kill(2), cgroups(8)

AUTOR
Kjetil Torgrim Homme (kjetilho@ifi.uio.no)

RELATANDO ERROS
Por favor, envie relatórios de erros para procps@freelists.org